# Changelog

## Version 1.3

### Added
- Implemented Restic installation using a precompiled binary to reduce memory usage.
- Added logic to create the Restic password file if it doesn't exist during installation.
- Automatic installation of the cronnext tool for next-run calculation.

### Fixed
- Resolved issue with missing Restic password file causing auto backup configuration to fail.
- Corrected permissions and ownership for the Restic password file to ensure it is accessible by the `litespeed` user.
- Updated the `installRestic` section in `manifest.jps` to generate a random password for the Restic password file during installation.
- Ensured consistent usage of the Restic password across all scripts by reading it from the `/etc/restic-password` file.
- Adjusted the `importScripts` section in `manifest.jps` to set the correct ownership for all backup-related directories to `litespeed:litespeed`.

### Updated
- Updated `manifest.jps` to ensure Restic password file creation and log rotation setup.

### Improved
- Improved logging with timestamps and detailed error/warning levels.
- Enhanced fallback mechanism to manually calculate the next run time for common cron schedules.
- Implemented notifications via Slack and email for failures or issues.
- Optimized error handling to gracefully manage unsupported schedules or tool failures.
     